%This is a Matlab script developed by Konstantinos Glynis
%based on the analysis of (https://www.itia.ntua.gr/el/docinfo/2079/)
%K. Glynis, T. Iliopoulou, P. Dimitriadis, and D. Koutsoyiannis, Stochastic investigation 
%of daily air temperature extremes from a global ground station network

clc; clear all; close all; tic;

%Search for non-zero data files

[~,stations] = xlsread('Data_List_Tmax.xlsx');

for i = 1:length(stations);
    filename = strcat('NOAA_GHCND_TMAX/',string(stations(i)));
    load(filename,'S'); %loading of time series
    m(i,1) = numel(find(S(:,4)))/365.25;
end

save('numyears_Tmax.mat','m');

toc;