%This is a Matlab script developed by Konstantinos Glynis
%based on the analysis of (https://www.itia.ntua.gr/el/docinfo/2079/)
%K. Glynis, T. Iliopoulou, P. Dimitriadis, and D. Koutsoyiannis, Stochastic investigation 
%of daily air temperature extremes from a global ground station network

clc; clear all; close all;

minimum = 30; %minimum record length
maximum = inf; %maximum record length
limit1 = 1935; %latest year of record start

prompt = 'Tavg | Tmax | Tmin : ';
str_temp = input(prompt,'s');
tic;

load(strcat('MonteCarlo_timeseries_',str_temp,'_v2.mat'));

size1 = 245;
temp1 = 0;
for number = 1:size1;
    n=numel(T(number,:));
    temp1 = temp1+1;
    clear Scale;
    Scale = [1:100 110:10:1000 1100:100:round(n/10)];
    max_Scale(temp1) = Scale(1,end);
    length_n(temp1) = n;
    ExpectedOne(temp1,1:length(Scale)) = pdClandHfast(T(number,:)',Scale)';
end
ExpectedOne(:,find(ismember(Scale,100*floor(mean(length_n)/1000)))+1:end) = [];
ExpectedOne(ExpectedOne==0) = NaN;

clear size

N = size(ExpectedOne,1);
a = size(ExpectedOne,2);
ExpectedCl = NaN(a,2);
for temp1 = 1:a;
    yMean(temp1) = nanmean(ExpectedOne(:,temp1));
    ExpectedCl(temp1,1:2) = quantile(ExpectedOne(:,temp1),[0.05 0.95]);
end

clear n; clear Scale;
n = floor(mean(length_n));
Scale = [1:100 110:10:1000 1100:100:round(n/10)];
xlswrite(strcat('FHK_',str_temp,'.xlsx'),Scale',1,'A1');
xlswrite(strcat('FHK_',str_temp,'.xlsx'),yMean',1,'B1');
xlswrite(strcat('FHK_',str_temp,'.xlsx'),ExpectedCl,1,'C1');

toc;