%This is a Matlab script developed by Panayiotis Dimitriadis and Konstantinos Glynis
%based on the analysis of (https://www.itia.ntua.gr/el/docinfo/2079/)
%K. Glynis, T. Iliopoulou, P. Dimitriadis, and D. Koutsoyiannis, Stochastic investigation 
%of daily air temperature extremes from a global ground station network

function [Ans] = pdClandHfast(S,k)

% function [H,x1,y1] = pdClandHfast(S,k)

CCl=NaN(numel(k),1);
for I=1:numel(k);
    C=S; 
    F=factor(k(I));
    if k(I)<50;
        for J=1:numel(F);
            if F(J)<=17;
                A=zeros(numel(C)+F(J)-1,F(J));
                for L=1:F(J);
                    A(L:end+L-F(J),L)=C;
                end
                B=nansum(A,2)/F(J);
                C=B(F(J):F(J):end-F(J)+1);
            else NN=numel(C);
                A=zeros(floor(NN/F(J)),1);
                for L=1:floor(NN/F(J));
                    A(L,1)=nansum(C(F(J)*(L-1)+1:F(J)*L,1))/F(J);
                end;
                C=A;
            end
        end
    else
        NN=numel(S);
        A=zeros(floor(NN/k(I)),1);
        for L=1:floor(NN/k(I));
            A(L,1)=nansum(S(k(I)*(L-1)+1:k(I)*L,1))/k(I);
        end;
        C=A;
    end
    CCl(I,:)=[nanvar(C)];
end

Ans = CCl;

end